package ch.std.meteo.service;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import ch.std.meteo.jpa.MeteoData;
import ch.std.meteo.repositories.MeteoDataRepository;

@Service
public class MeteoService {

	@Autowired
	private MeteoDataRepository meteoDataRepository;
	
	public MeteoService() {
	}
	
	public List<MeteoData> getMeteoDaten() {
		return this.meteoDataRepository.findAll();
	}
	
	public MeteoMetrics getMeteoMetrics() {
		List<MeteoData> meteoDataList = this.getMeteoDaten();
		MeteoMetrics meteoMetrics = new MeteoMetrics(meteoDataList);
		return meteoMetrics;
	}
	
	public static class MeteoMetrics {
		private double min;
		private double max;
		private double med ;
		public MeteoMetrics(List<MeteoData> meteoDataList) {
			this.min = meteoDataList.get(0).getTemperature();
			this.max = meteoDataList.get(0).getTemperature();
			this.med = 0.0;
			meteoDataList.forEach(md -> {
				double t = md.getTemperature();
				if (t < min) { 
					min = t;
				}
				if (t > max) { 
					max = t;
				}
				med += t;
			});
			this.med /= meteoDataList.size();
		}
		
		public double getMin() {
			return min;
		}
		
		public double getMax() {
			return max;
		}
		
		public double getMed() {
			return med;
		}
	}
}
